/*
 * Copyright (c) 1983 Eric P. Allman
 * Copyright (c) 1988 Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted provided
 * that: (1) source distributions retain this entire copyright notice and
 * comment, and (2) distributions including binaries display the following
 * acknowledgement:  ``This product includes software developed by the
 * University of California, Berkeley and its contributors'' in the
 * documentation or other materials provided with the distribution and in
 * all advertising materials mentioning features or use of this software.
 * Neither the name of the University nor the names of its contributors may
 * be used to endorse or promote products derived from this software without
 * specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

/*
**  AIXRT.H -- configurable parameters for sendmail on IBM RTs w. AIX.
*/

#define VMUNIX		1	/* running on systems w. 4.2/4.3 networking */
#define SIG_TYPE	int	/* Value returned by signal() */
#define TIME_TYPE	time_t	/* Value used and returned by time() */
#define FCNTL_FLOCK	1	/* Berkeley flock() emulation using fcntl() */
#define SYSV		1	/* running on a system 5 system */
#define HAVE_UNAME	1	/* System has the uname() call */
#define HAVE_WAIT3	1	/* has the wait3() call */
#define LACK_STRSEP	1	/* Need the strsep() call for uiuc/phquery.c */
#ifdef __STDC__
struct passwd * getpwuid(uid_t);
struct passwd * getpwnam(const char *);
#else /* !__STDC__ */
struct passwd * getpwuid();
struct passwd * getpwnam();
#endif /* __STDC__ */
#include <sys/time.h>
